package algebra.words;

import java.util.*;

/**
 * @author Anton Mellit
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class Alphabet {
	private SortedMap nameToLetter;
	
	public Alphabet() {
		nameToLetter = new TreeMap();
	}
	
	public void addLetter(Letter l) {
		nameToLetter.put(l.getName(), l);
	}
	
	public Letter getFirstLetter(String str) {
		SortedMap head = nameToLetter.headMap(str+" ");
		if(head.isEmpty()) {
			return null;
		}
		String subst = (String) head.lastKey();
		if(str.startsWith(subst)) {
			return (Letter) nameToLetter.get(subst);
		} else {
			return null;
		}
	}
	public void dump() {
		System.out.println("Alphabet:");
		for (Iterator iter = nameToLetter.entrySet().iterator(); iter.hasNext();) {
			Letter l = (Letter)((Map.Entry) iter.next()).getValue();
			l.dump();
		} 
	}
	public Letter[] getLetters() {
		Letter[] res = new Letter[nameToLetter.size()];
		int k = 0;
		for (Iterator iter = nameToLetter.entrySet().iterator(); iter.hasNext();) {
			Letter l = (Letter)((Map.Entry) iter.next()).getValue();
			res[k] = l;
			k++;
		} 
		return res;
	}
}
