package algebra.words;

/**
 * @author Anton Mellit
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class Letter implements Comparable{
	private String name;
	private boolean central;
	private int level;
	private int index;
	
	public Letter(String name) {
		this.name = name;
		this.level = 0;
		this.index = 0;
		this.central = false;
	}
	
	public Letter(String name, boolean central) {
		this.name = name;
		this.level = central ? -1 : 0;
		this.central = central;
		this.index = 0;
	}
	
	public Letter(String name, boolean central, int level) {
		this.name = name;
		this.level = level;
		this.central = central;
		this.index = 0;
	}
	
	public Letter(String name, boolean central, int level, int index) {
		this.name = name;
		this.level = level;
		this.central = central;
		this.index = index;
	}
	/**
	 * Returns the central.
	 * @return boolean
	 */
	public boolean isCentral() {
		return central;
	}

	/**
	 * Returns the highIndex.
	 * @return int
	 */
	public int getLevel() {
		return level;
	}

	/**
	 * Returns the lowIndex.
	 * @return int
	 */
	public int getIndex() {
		return index;
	}

	/**
	 * Returns the name.
	 * @return String
	 */
	public String getName() {
		return name;
	}

	/**
	 * Sets the central.
	 * @param central The central to set
	 */
	public void setCentral(boolean central) {
		this.central = central;
	}

	/**
	 * Sets the highIndex.
	 * @param highIndex The highIndex to set
	 */
	public void setLevel(int highIndex) {
		this.level = highIndex;
	}

	/**
	 * Sets the lowIndex.
	 * @param lowIndex The lowIndex to set
	 */
	public void setIndex(int lowIndex) {
		this.index = lowIndex;
	}

	/**
	 * @see java.lang.Comparable#compareTo(Object)
	 */
	public int compareTo(Object o) {
		Letter l = (Letter) o;
		if(level!=l.level) {
			return level-l.level;
		} 
		if(index!=l.index) {
			return index-l.index;
		}
		return name.compareTo(l.name);
	}

	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return name;
	}

	public void dump() {
		System.out.println(name+" "+(central?"Central":"Noncentral")+" weight "+level+" index "+index);
	}
}
