package calculus;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Vector;

import algebra.numbers.Rational;
import algebra.words.Alphabet;
import algebra.words.Letter;
import algebra.words.Word;

/**
 * @author Anton Mellit
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class Main {

	public static void printBaseWords(String letters, String[] g, Alphabet abc) {
		Vector words = new Vector();
		words.add("");
		int k = 0;
		for(int i = 0; i<words.size(); i++) {
			String s = (String) words.get(i);
			System.out.print(Word.parseString(s, abc).toString()+", ");
			for(int j = 0; j<letters.length(); j++) {
				String s2 = s+letters.substring(j, j+1);
				boolean ok = true;
				for(int jj = 0; jj<g.length; jj++) {
					if(s2.indexOf(g[jj])>=0) {
						ok = false;
						break;
					}
				}
				if(ok) {
					words.add(s2);
				}
			}
		}
		System.out.println();
		System.out.println("Total: "+words.size());
	}
	public static void main(String[] args) {
		Alphabet abc = new Alphabet();
		abc.addLetter(new Letter("A"));
		abc.addLetter(new Letter("B"));
		abc.addLetter(new Letter("C"));
	//	abc.addLetter(new Letter("D"));
	//	abc.addLetter(new Letter("z0", false, 50, 1));
	//	abc.addLetter(new Letter("z1", false, 50, 2));
	//	abc.addLetter(new Letter("z2", false, 50, 3));
	//	abc.addLetter(new Letter("z3", false, 50, 4));
	//	abc.addLetter(new Letter("z4", true, -50, 5));
	//	abc.addLetter(new Letter("e", true, -10, 5));
		abc.addLetter(new Letter("a0", true, -4, 1));
		abc.addLetter(new Letter("a1", true, -4, 2));
		abc.addLetter(new Letter("a2", true, -4, 3));
		abc.addLetter(new Letter("a3", true, -4, 4));
		abc.addLetter(new Letter("a4", true, -4, 5));
		abc.addLetter(new Letter("a5", true, -4, 6));
		abc.addLetter(new Letter("b0", true, -4, 7));
		abc.addLetter(new Letter("b1", true, -4, 8));
		abc.addLetter(new Letter("b2", true, -4, 9));
		abc.addLetter(new Letter("b3", true, -4, 10));
		abc.addLetter(new Letter("c0", true, -4, 11));
		abc.addLetter(new Letter("c1", true, -4, 12));
		abc.addLetter(new Letter("c2", true, -4, 13));
		abc.addLetter(new Letter("d0", true, -4, 14));
		abc.addLetter(new Letter("d1", true, -4, 15));
//		abc.addLetter(new Letter("c2", true, -5));
		Groebner g = new Groebner();
		g.setDump(true);
//		g.addRelation(WordSum.parse("d0d1^2+d0^2d1+a1d0d1+a2d0+a3d1+a4", abc));
//		g.addRelation(WordSum.parse("d1^2+2d0d1+a1d1+a2", abc));
//		g.addRelation(WordSum.parse("d0^2+2d0d1+a1d0+a3", abc));
		g.addRelation(WordSum.parse("ABC+BAC-CAB-CBA", abc));
		g.addRelation(WordSum.parse("AC-CA", abc));
		g.addRelation(WordSum.parse("CC-1", abc));
		g.addRelation(WordSum.parse("AAA-a2AA-a1A", abc));
		g.addRelation(WordSum.parse("BBB-b2BB-b1B-b0", abc));
//		g.addRelation(WordSum.parse("CC", abc));
//		g.addRelation(WordSum.parse("BAB", abc));
//		g.addRelation(WordSum.parse("BAB-a0B", abc));
//		g.addRelation(WordSum.parse("BCB", abc));
//		g.addRelation(WordSum.parse("CBC", abc));
//		g.addRelation(WordSum.parse("CDC", abc));
//		g.addRelation(WordSum.parse("DCD", abc));
//		g.addRelation(WordSum.parse("DAD", abc));
//		g.addRelation(WordSum.parse("ADA", abc));
//		g.addRelation(WordSum.parse("BCB-a1B", abc));
//		g.addRelation(WordSum.parse("CA", abc));
//		g.addRelation(WordSum.parse("AC", abc));
//		g.addRelation(WordSum.parse("AA", abc));
//		g.addRelation(WordSum.parse("AC", abc));
//		g.addRelation(WordSum.parse("CA", abc));
//		g.addRelation(WordSum.parse("BD", abc));
//		g.addRelation(WordSum.parse("DB", abc));
//		g.addRelation(WordSum.parse("BB", abc));
//		g.addRelation(WordSum.parse("CC", abc));
//		g.addRelation(WordSum.parse("DD", abc));
//		g.addRelation(WordSum.parse("- z3 + 2a1A - b1A - a1B + a2A^2 + b2A^2 - 2c0A^2 - a2AB - a2BA + A^3B + A^2BA + ABA^2 + BA^3", abc));
//		g.addRelation(WordSum.parse("D^2", abc));
//		g.addRelation(WordSum.parse("A^3", abc));
//		g.addRelation(WordSum.parse("B^3", abc));
//		g.addRelation(WordSum.parse("C^3", abc));
//		g.addRelation(WordSum.parse("D^2", abc));
//		g.addRelation(WordSum.parse("a1-2", abc));
//		g.addRelation(WordSum.parse("b1-1", abc));
//		g.addRelation(WordSum.parse("c1-1", abc));
//		g.addRelation(WordSum.parse("a0-1", abc));
//		g.addRelation(WordSum.parse("b0-1", abc));
//		g.addRelation(WordSum.parse("c0-1", abc));
//		g.addRelation(WordSum.parse("d0-1", abc));
		g.mergeRelations();
		g.groebnerClosure();
//		String[] gg = {"AA", "BB", "CC", "CB", "BA", "CA"};
//		printBaseWords("ABC", gg, abc);
//		System.exit(0);
		Letter[] generators = Word.parseString("ABC", abc).getLetters();
		Letter[] letters = Word.parseString("ABCa0a1a2b0b1b2", abc).getLetters();
//		Letter[] letters = Word.parseString("ABC", abc).getLetters();
//			abc.getFirstLetter("C"), abc.getFirstLetter("a0"), abc.getFirstLetter("a1"),
//			abc.getFirstLetter("b0"), abc.getFirstLetter("b1"), abc.getFirstLetter("c0"),
//			abc.getFirstLetter("c1"), abc.getFirstLetter("d0")};
		int k = 0;
		while(true) {
			if(k==2) break;
			CenterAnalysis ca = new CenterAnalysis(generators, letters, g.getRelations());
			ca.setDump(true);
			WordSum center = ca.findCenter();
			if(center==null) break;
			WordSum s = new WordSum();
			s.add(center, Word.ONE, Word.parseString("A", abc), Rational.ONE);
			s.add(center, Word.parseString("A", abc), Word.ONE, Rational.ONE.multiply(-1));
			s.reduce(g.getRelations());
			if(!s.isZero()) {
				System.out.println("Error");
				return;
			}
			s.add(center, Word.ONE, Word.parseString("B", abc), Rational.ONE);
			s.add(center, Word.parseString("B", abc), Word.ONE, Rational.ONE.multiply(-1));
			s.reduce(g.getRelations());
			if(!s.isZero()) {
				System.out.println("Error");
				return;
			}
			String newLetter = "x"+k;
//			if(k<2) {
				abc.addLetter(new Letter(newLetter, true, -3, k+1));
//			} else {
//				abc.addLetter(new Letter(newLetter, false, 2));
//			}
			center.add(new Word(abc.getFirstLetter(newLetter)), -1);
			g.addRelation(center);
			g.mergeRelations();
			g.groebnerClosure();
			Letter[] letters0 = letters;
			letters = new Letter[letters0.length+1];
			for(int i = 0; i<letters0.length; i++) {
				letters[i] = letters0[i];
			}
			letters[letters0.length] = abc.getFirstLetter(newLetter);
//			if(k==2) break;
			k++;
		}
//		abc.addLetter(new Letter("y1", true));
//		abc.addLetter(new Letter("y2", true));
//		abc.addLetter(new Letter("y3", true));
//		abc.addLetter(new Letter("y4", true));
//		abc.addLetter(new Letter("y5", true));
//		abc.addLetter(new Letter("y6", true));
		
//		abc.addLetter(new Letter("X0", true, -10, 1));
//		abc.addLetter(new Letter("Y0", true, -10, 2));
//		abc.addLetter(new Letter("Z0", true, -10, 3));
//		abc.addLetter(new Letter("T", true, -11, 3));
//		abc.addLetter(new Letter("X1", true, -9, 1));
//		abc.addLetter(new Letter("Y1", true, -9, 2));
//		abc.addLetter(new Letter("Z1", true, -9, 3));
//		g.addRelation(WordSum.parse("X0-x1", abc));
//		g.addRelation(WordSum.parse("Y0-x0", abc));
//		g.addRelation(WordSum.parse("Y0^4+4X0^3", abc));
//		g.addRelation(WordSum.parse("Z0-x0^2-6x2", abc));
//		g.addRelation(WordSum.parse("Z0", abc));
//		g.addRelation(WordSum.parse("X0+4T^4", abc));
//		g.addRelation(WordSum.parse("Y0-4T^3", abc));
//		g.addRelation(WordSum.parse("X0X1-1", abc));
//		g.addRelation(WordSum.parse("Y0Y1-1", abc));
//		g.addRelation(WordSum.parse("Z0Z1-1", abc));
//		g.mergeRelations();
//		g.groebnerClosure();
		
		System.out.println("Ready for calculations, you may enter statements, type exit to exit");
		BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
		try {
			while(true) {
				String line = reader.readLine();
				if(line.equalsIgnoreCase("exit")) {
					break;
				}
				WordSum res;
				try {
					res = WordSum.parse(line, abc);
				}catch(Error e) {
					System.out.println("Your input is incorrect, please try again");
					continue;
				}
				res.reduce(g.getRelations());
				System.out.println(res);
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
/*		
		while(true) {
			CenterAnalysis ca = new CenterAnalysis(generators, letters, g.getRelations());
			ca.setDump(true);
			WordSum center = ca.findCenter();
			if(center==null) break;
			String newLetter = "x"+k;
			abc.addLetter(new Letter(newLetter, true, -1, k+1));
			center.add(new Word(abc.getFirstLetter(newLetter)), -1);
			g.addRelation(center);
			g.mergeRelations();
			g.groebnerClosure();
			Letter[] letters0 = letters;
			letters = new Letter[letters0.length+1];
			for(int i = 0; i<letters0.length; i++) {
				letters[i] = letters0[i];
			}
			letters[letters0.length] = abc.getFirstLetter(newLetter);
			k++;
		}*/
	}
}
